//libiraries
#include <Servo.h>

//pin connections to the board
const int ledPin = 8;
const int buttonPin = 4;
const int ninjaPin = 9;
const int enemyPin = 6;
const int doorPin = 10;

//timed events
float ninjaActivateTime = 2000.0; //delay before the ninja is activated
float enemyActivateTime = 3200.0; //delay before the enemy is activated
float doorActivateTime = 4000.0; //delay before the door is activated


//button variables
int buttonState = 0;
int buttonActive = 0; //bool checking if the diorama should be running or not
float savedMillis;
int runningShow = 0;

//servo variables
Servo servoNinja;//servo connected to the lego ninja
int servoNinjaPos = 0; 
float ninjaSpeed = 1.0f;
Servo servoEnemy; //servo connected to the lego skeleton enemy
int servoEnemyPos = 0;
float enemySpeed = 1.0f;
Servo servoDoor; //servo connected to the lego cave door
int servoDoorPos = 0;
int doorTurn = 120;
float doorSpeed = 1.0f;


void setup() {

  Serial.begin(9600);

  //Pin Connections
  pinMode(ledPin, OUTPUT);
  pinMode(buttonPin, INPUT);
  servoNinja.attach(ninjaPin);
  servoEnemy.attach(enemyPin);
  servoDoor.attach(doorPin);

 //setup starting positions
  int servoNinjaPos = 0;
  int servoEnemyPos = 0;
  int servoDoorPos = 0;
  int runningShow = 0;
  
  buttonActive = 0;

}

void loop() {
  buttonState = digitalRead(buttonPin); 
  //Serial.println("reading button pin");

  if(buttonState == HIGH) { //check if the button is pressed
  Serial.println("Buttonstate = HIGH");
    if(buttonActive == 0) {
      buttonActive = 1;
      savedMillis = millis();
      Serial.println("Button Pressed");

      runningShow = 1;

    }
  }


  if(runningShow == 1) { //if the button has been pressed, run the following code:

    digitalWrite(ledPin, HIGH); //turn on the LED

//fighting animations
 if(millis() >= (savedMillis + ninjaActivateTime)) {
NinjaFights(70);
 }

 if(millis() >= (savedMillis + enemyActivateTime)) {
EnemyFights(90);
 }

 if(millis() >= (savedMillis + ninjaActivateTime)) {
NinjaFights(100);
 }

  if(millis() >= (savedMillis + enemyActivateTime)) {
EnemyFights(110);
 }

  if(millis() >= (savedMillis + ninjaActivateTime)) {
NinjaFights(60);
 }


    //door servo activation
  if(millis() >= (savedMillis + doorActivateTime)) {

         for (servoDoorPos = 0; servoDoorPos <= doorTurn; servoDoorPos += doorSpeed) { // goes from 0 degrees to max degrees
    // in steps of 1 degree
    servoDoor.write(servoDoorPos);              // tell servo to go to position
    delay(85);                       // waits for the servo to reach position
  }
  delay(1500);
  for (servoDoorPos = doorTurn; servoDoorPos >= 0; servoDoorPos -= doorSpeed) { // goes from max degrees to 0 degrees
    servoDoor.write(servoDoorPos);              // tell servo to go to position
    delay(85);                       // waits for the servo to reach position
  }
  runningShow = 0;
    buttonActive = 0;

  }

  } else {
    digitalWrite(ledPin, LOW); //turn off the LED if the button has not been pressed
  }

  }


void NinjaFights(int ninjaTurn) {  //ninja servo activation

         for (servoNinjaPos = 0; servoNinjaPos <= ninjaTurn; servoNinjaPos += ninjaSpeed) { // goes from 0 degrees to max degrees
    // in steps of 1 degree
    servoNinja.write(servoNinjaPos);              // tell servo to go to position
    delay(15);                       // waits for the servo to reach position
  }
  for (servoNinjaPos = ninjaTurn; servoNinjaPos >= 0; servoNinjaPos -= ninjaSpeed) { // goes from max degrees to 0 degrees
    servoNinja.write(servoNinjaPos);              // tell servo to go to position
    delay(15);                       // waits for the servo to reach position
  }

}

void EnemyFights(int enemyTurn) {   //enemy sero activation

    Serial.println("Enemy Servo Active");

         for (servoEnemyPos = enemyTurn; servoEnemyPos >= 0; servoEnemyPos -= enemySpeed) { // goes from 0 degrees to max degrees
    // in steps of 1 degree
    servoEnemy.write(servoEnemyPos);              // tell servo to go to position
    delay(15);                       // waits for the servo to reach position
  }
  for (servoEnemyPos = 0; servoEnemyPos <= enemyTurn; servoEnemyPos += enemySpeed) { // goes from max degrees to 0 degrees
    servoEnemy.write(servoEnemyPos);              // tell servo to go to position
    delay(15);                       // waits for the servo to reach position
  

}

}